Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _request2 = require('request');

var _request3 = _interopRequireDefault(_request2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var request = _bluebird2['default'].promisifyAll(_request3['default']);

exports['default'] = function (Topics, settings, handle /* TODO , savePost */) {
  return function (userRequest) {
    // request original-post then wrap and post it
    // return Promise resolve with postData or topicData
    var _userRequest$body = userRequest.body,
        url = _userRequest$body.url,
        cid = _userRequest$body.cid,
        tid = _userRequest$body.tid;
    var uid = userRequest.uid;

    if (!(cid || tid)) {
      return _bluebird2['default'].reject(Error('[[error:missing-place-to-post]]'));
    }
    // console.log(url);
    if (!url || typeof url !== 'string') {
      return _bluebird2['default'].reject(Error('[[error:invalid-url]]'));
    }

    var getInputData = function getInputData(_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          res = _ref2[0],
          pluginSettings = _ref2[1];

      return {
        raw: res.body,
        settings: pluginSettings,
        info: {
          url: url,
          uid: uid,
          cid: cid,
          tid: tid
        }
      };
    };

    var appendUid = function appendUid(args) {
      return Object.assign({}, args, { uid: uid });
    };

    var savePost = void 0;

    // TODO move these two branches into separate modules
    // delegate control to init.js
    if (cid) {
      var appendCid = function appendCid(args) {
        return Object.assign({}, args, { cid: cid });
      };
      savePost = function savePost(postData) {
        return _bluebird2['default'].resolve(postData).then(appendCid).then(Topics.postAsync).then(function (data) {
          return { tid: data.topicData.tid };
        });
      };
    } else /* if (tid) */{
        var appendTid = function appendTid(args) {
          return Object.assign({}, args, { tid: tid });
        };
        savePost = function savePost(postData) {
          return _bluebird2['default'].resolve(postData).then(appendTid).then(Topics.replyAsync).then(function (data) {
            return { pid: data.pid };
          });
        };
      }

    return _bluebird2['default'].all([request.getAsync(url), settings.getAsync('leech-tool')]).then(getInputData).then(handle).then(appendUid).then(savePost);
  };
};
//# sourceMappingURL=leech.js.map