Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require('../lib/utils');

exports['default'] = function (models, Renderer) {
  var Model = {};

  Model.s = models;
  Model.mapToRenderers = (0, _utils.swapKeyValue)(Renderer.mapToModel, true);

  Model.test = function (parsing) {
    return Promise.resolve(parsing).then(function (parsed) {
      var modelName = parsed.modelName;

      if (!models[modelName].test(parsed)) return Promise.reject(Error('[[error:invalid-parsed-data]]'));
      return parsed;
      // TODO test postData model (return value)
    });
  };

  return Model;
};
//# sourceMappingURL=model.js.map