Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = function (Model, leech) {
  var Controllers = {};

  Controllers.renderAdminPage = function () {
    function renderAdminPage(req, res) {
      /*
        Make sure the route matches your path to template exactly.
         If your route was:
        myforum.com/some/complex/route/
        your template should be:
        templates/some/complex/route.tpl
        and you would render it like so:
        res.render('some/complex/route');
      */

      res.render('admin/plugins/leech-tool', {
        models: Object.keys(Model.s),
        renderersFromModel: Model.mapToRenderers
      });
    }

    return renderAdminPage;
  }();

  Controllers.leechToolAPI = function (req, res) {
    var sendJSON = _lodash2['default'].bind(res.json, res);
    leech(req)['catch'](console.log).then(sendJSON, sendJSON);
  };

  return Controllers;
};
//# sourceMappingURL=controllers.js.map