Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.swapKeyValue = exports.toArray = undefined;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var toArray = exports.toArray = function toArray(obj) {
  if (!obj) {
    return [];
  } else if (obj instanceof Array) {
    return obj;
  }
  return [obj];
};

var swapKeyValue = exports.swapKeyValue = function swapKeyValue(map, allValueIsArray) {
  var result = {};
  _lodash2['default'].forEach(map, function (value, key) {
    var curr = result[value];
    if (allValueIsArray || curr !== undefined && !(curr instanceof Array)) {
      result[value] = toArray(curr);
      result[value].push(key);
    } else if (curr === undefined) {
      result[value] = key;
    } else /* if (curr instanceof Array) */{
        result[value].push(key);
      }
  });
  return result;
};
//# sourceMappingURL=utils.js.map