Object.defineProperty(exports, "__esModule", {
  value: true
});

var _htmlMinifier = require('html-minifier');

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = function (args) {
  return new Promise(function (resolve, reject) {
    var raw = args.raw;

    var minifiedHtml = (0, _htmlMinifier.minify)(raw, {
      removeComments: true
    });
    var $ = _cheerio2['default'].load(minifiedHtml);
    var generator = $('head > meta[name="generator"]').attr('content');
    if (generator === 'vBulletin 3.8.0') {
      var result = Object.assign({}, args);
      delete result.raw;
      result.$ = $;
      resolve(result);
    }
    reject(Error('Inappropriate parser'));
  });
};
//# sourceMappingURL=check.js.map